<?php

//https://xxxxxxxxxxxxxxx.vn/callback.php?username=lnq003&password=96a3e5595e9d06ea961e748b0&amount=10000&tran_id=4c27fa92dec4ac8ed1d0050416d161bf&errorcode=9&messages=s62eh7148&signature=1f500c0501ad5cfdf01a73b2ba69abffef1ad0336f21c54c6a2f326d5f75717e



$username = anti_injection($_GET['username']);
$password = anti_injection($_GET['password']);
$amount = intval ($_GET['amount']);
$errorcode = intval ($_GET['errorcode']);
$tran_id = anti_injection($_GET['tran_id']);
$messages = escapeString($_GET['messages']);
$signature = anti_injection($_GET['signature']);


$secure = verify_wehook($username,$password,$amount,$tran_id,$errorcode,$messages,$signature);

if($secure){
	//trạng thái đúng , cho phép cộng tiền
	echo "Chữ ký đúng";
	
} else {
	echo "chữ ký sai";
}


	//Anti Injection
	function anti_injection($post_value)
	{
		$banlist = array(
			' insert ', ' select ', ' update ', ' delete ', 'distinct ', ' having ',
			' truncate ', ' replace ', ' handler ', ' like ', ' as ', ' or ',
			' procedure ', ' limit ', ' order by ', ' group by ', ' asc ', ' desc ',
			'concat(', '(select', '/insert', '/select', '/update', '/delete', '/distinct', '/having',
			'/truncate', '/replace', '/handler', '/like', '/as', '/or', '/procedure', '/limit',
			'/order by', '/group by', '/asc', '/desc',
			'chr(', 'chr=', 'chr%20', '%20chr', 'wget%20', '%20wget', 'wget(',
			'cmd=', '%20cmd', 'cmd%20', 'rush=', '%20rush', 'rush%20',
			'union%20', '%20union', 'union(', 'union=', 'echr(', '%20echr', 'echr%20', 'echr=',
			'esystem(', 'esystem%20', 'cp%20', '%20cp', 'cp(', 'mdir%20', '%20mdir', 'mdir(',
			'mcd%20', 'mrd%20', 'rm%20', '%20mcd', '%20mrd', '%20rm',
			'mcd(', 'mrd(', 'rm(', 'mcd=', 'mrd=', 'mv%20', 'rmdir%20', 'mv(', 'rmdir(',
			'chmod(', 'chmod%20', '%20chmod', 'chmod(', 'chmod=', 'chown%20', 'chgrp%20', 'chown(', 'chgrp(',
			'locate%20', 'grep%20', 'locate(', 'grep(', 'diff%20', 'kill%20', 'kill(', 'killall',
			'passwd%20', '%20passwd', 'passwd(', 'telnet%20', 'vi(', 'vi%20',
			'insert%20into', 'select%20', 'nigga(', '%20nigga', 'nigga%20', 'fopen', 'fwrite', '%20like', 'like%20',
			'$_request', '$_get', '$request', '$get', '.system', 'HTTP_PHP', '&aim', '%20getenv', 'getenv%20',
			'new_password', '&icq', '/etc/password', '/etc/shadow', '/etc/groups', '/etc/gshadow',
			'HTTP_USER_AGENT', 'HTTP_HOST', '/bin/ps', 'wget%20', 'uname\x20-a', '/usr/bin/id',
			'/bin///echo', '/bin/kill', '/bin/', '/chgrp', '/chown', '/usr/bin', 'g\+\+', 'bin/python',
			'bin/tclsh', 'bin/nasm', 'perl%20', 'traceroute%20', 'ping%20', '.pl', '/usr/X11R6/bin/xterm', 'lsof%20',
			'/bin/mail', '.conf', 'motd%20', 'HTTP/1.', '.inc.php', 'config.php', 'cgi-', '.eml',
			'file\://', 'window.open', '<SCRIPT>', 'javascript\://', 'img src', 'img%20src', '.jsp', 'ftp.exe',
			'xp_enumdsn', 'xp_availablemedia', 'xp_filelist', 'xp_cmdshell', 'nc.exe', '.htpasswd',
			'servlet', '/etc/passwd', 'wwwacl', '~root', '~ftp', '.js', '.jsp', 'admin_', '.history',
			'bash_history', '.bash_history', '~nobody', 'server-info', 'server-status', 'reboot%20', 'halt%20',
			'powerdown%20', '/home/ftp', '/home/www', 'secure_site, ok', 'chunked', 'org.apache', '/servlet/con',
			'<script', '/robot.txt', '/perl', 'mod_gzip_status', 'db_mysql.inc', '.inc', 'select%20from',
			'select from', 'drop%20', '.system', 'getenv', 'http_', '_php', 'php_', 'phpinfo()', '<?php', '?>', 'sql=',
			'!', '@', '#', '$', '%', '^', '&', '*', '(', ')', '=', '%20', ',', '<', '>', '--',
			'csleep', 'XOR', 'script'

		);

		// ---------------------------------------------

		if (preg_match('/[a-zA-Z0-9]+/', $post_value)) {
			$post_value = trim(str_replace($banlist, '', strtolower($post_value)));
			$post_value = stripslashes($post_value);
		} else {
			$post_value = NULL;
		}

		return $post_value;
	}

	function verify_wehook($username,$password,$amount,$tran_id,$errorcode,$messages,$signature){
		$str = $username . $password. $amount . $tran_id . $errorcode . $messages;
		$secure = hash('sha256',$str); 
		if($secure != $signature)
			return false;
		else
			return true;
	}
	
    function escapeString($value) {
        $value = htmlspecialchars(strip_tags(trim($value)));
        return $value;
    }